#include <signal.h>
#include <stdio.h>

#include <windows.h>

int cnt;
HWND window;
volatile int x = 0;

void ctrl_c_handler(int x)
{
  signal(SIGINT, ctrl_c_handler);
  printf("sig=%d cnt=%d\n", x, ++cnt);
}

LRESULT CALLBACK window_proc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message) 
    {
    case WM_DESTROY:
      PostQuitMessage(0);
      x=1;
      break;
      
    default:
      return DefWindowProc(hWnd, message, wParam, lParam);
  }
  return 0;
}

void create_win()
{
  HINSTANCE hInstance;
  WNDCLASSEX wcex; 
             
  hInstance = GetModuleHandle(NULL);
    
  wcex.cbSize = sizeof(wcex);
  wcex.style = CS_HREDRAW | CS_VREDRAW;
  wcex.lpfnWndProc = window_proc;
  wcex.cbClsExtra = 0;
  wcex.cbWndExtra = 0;
  wcex.hInstance = hInstance;
  wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
  wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
  wcex.lpszMenuName = NULL;
  wcex.lpszClassName = "CtrlCWin";
  wcex.hIconSm = NULL;
                     
  if (RegisterClassEx(&wcex))
    {        
      window = CreateWindow("CtrlCWin", "CtrlCWin", WS_OVERLAPPEDWINDOW,
                                 CW_USEDEFAULT, CW_USEDEFAULT, 270, 230, NULL, 
                                 NULL, hInstance, NULL);
      if (window) 
        {
          ShowWindow(window, SW_SHOW);
          UpdateWindow(window);
        }
    }
}

int main()
{
  MSG msg;
  BOOL bRet;

  signal(SIGINT, ctrl_c_handler);
  
  create_win();

  while(!x)
  {
    /* If this call to PeekMessage is removed, signals get through */ 
    while (PeekMessage(&msg, window, 0, 0, PM_NOREMOVE)) 
      {
        bRet = GetMessage(&msg, window, 0, 0);
        if (bRet > 0) 
          {  
            TranslateMessage(&msg);
            DispatchMessage(&msg);
          }  
      }    
  }
  return 0;
}
